from openerp.osv import osv, fields
from datetime import datetime, timedelta
from openerp.tools.translate import _

class cpi_be_type(osv.osv):
    _name = 'cpi.be.type'
    
    _columns = {
        'name':fields.char("Name", size=255),
        'description':fields.char("Description", size=1024),  
        'entries':fields.one2many('cpi.be.entry','type_id', string='Entries')
    }
cpi_be_type()


class cpi_be_entry(osv.osv):
    _name = 'cpi.be.entry'
    
    _order = 'type_id, year desc, month desc, value' 
    
    def name_get(self, cr, uid, ids, context=None):
        if not ids:
            return []
        result = []
        for entry in self.browse(cr, uid, ids, context=context):
            result.append((entry.id,str(entry.year)+'/'+str(entry.month)))
        return result

    def name_search(self, cr, user, name, args=None, operator='ilike', context=None, limit=100):
        if not args:
            args = []
        if context is None:
            context = {}
        ids = []
        req_ids = []
        if name:
            cr.execute("select id from cpi_be_entry where to_char(month,'09')||'/'||year like %s",('%'+name+'%',))
            req_ids = map(lambda x: x[0], cr.fetchall())
        
        if name:
            ids = self.search(cr, user, [('id', 'in', req_ids)]+args, limit=limit)
        else:
            ids = self.search(cr, user, args, limit=limit)
        
        
        return self.name_get(cr, user, ids, context=context)
    
    _columns = {
        'type_id':fields.many2one('cpi.be.type', string="Type"),
        'year':fields.integer("Year"), 
        'month':fields.integer("Month"), 
        'value':fields.float("Value")
    }
    
    def _check_date(self, cr, uid, ids):
        for cpi in self.browse(cr, uid, ids):
            if cpi.month < 1 or cpi.month > 12:
                return False 
        return True
    
    _constraints = [(_check_date, 'Error: invalid month', ['month']), ]
    
    _sql_constraints = [
        ('cpi_be_entry_unique', 'unique(type_id,year,month)', 'For the same type, year and month must be unique')
    ]
    
     
    
cpi_be_entry()

class cpi_be_update_wizard(osv.osv_memory):
    _name = 'cpi.be.update.wizard'
    
    def action_update(self, cr, uid, ids, context):
        self.pool.get("scheduler.cpi_be").import_cpi_be_all(cr, uid, context=context)
        return {'type': 'ir.actions.act_window_close'}
    
cpi_be_update_wizard()
